#!/usr/bin/perl
#
# Kitten-0.2, used for checking file and directory permissions,
# plus a little more.
#
# Copyright (C) 1995, Olaf Kirch <okir@monad.swb.de>
# Covered by the GNU GPL Version 2.
#
# TODO:
#
# *	Better rules.
# *	Include directive for better structuring of db files
# *	User-supplied test code that checks for the presence of a package,
#	its pathname etc pp. With the ability to skip packages.
# *	chksuid should be clever about cdroms, nfs-mounted file systems,
# 	and nosuid/noexec fs flags.
# *	Generation of tripwire config file should be more clever.
# *	Do something useful with the package label.
#

$verbose = 0;			# mindless blather
$gentrip = 1;

# config sections ends here
$warnings = 0;
$errors = 0;

$SUID   = oct(4000);
$SGID   = oct(2000);
$RMODE  = oct(444);
$WMODE  = oct(222);
$XMODE  = oct(111);

$hostname = `hostname`;		chop($hostname);
$fullname = `hostname -f`;	chop($fullname);
$domainname = `hostname -d`;	chop($domainname);

&setup;

print STDERR "\n\t\tReport for $fullname\n";
print STDERR "---------------------- Messages -----------------------------\n";

push(@INC, "./klib");
foreach $check (<checks/*>) {
    print STDERR "--- Running $check...\n";
    require $check if (-x $check);
}

print STDERR "-------------------------------------------------------------\n";
print STDERR "\n\nWarnings: $warnings\t\t\tErrors: $errors\n";

exit;


##################################################################
# initialization
##################################################################
sub setup {

    # Set up array mapping uids/gids to names
    setpwent;
    while (($name, $pwd, $uid, $gid, $q, $c, $gecos, $dir, $shell) = getpwent) {
        $LOGIN{$uid} = $name;
        $HOME{$uid} = $dir;
        $UID{$name} = $uid;
        $GID{$name} = $gid;	# no easy way to make an array element a list...
    }
    endpwent;
    
    setgrent;
    while (($name, $pwd, $gid, $members) = getgrent) {
        $GROUP{$gid} = $name;
    }
    endgrent;
}

##################################################################
# output routines
##################################################################
sub setwarntag {
    $havewarned = 0;
    $warntag = $_;
}

sub warn {
    if ($havewarned == 0) {
	print STDERR "--- $warntag:\n";
	$havewarned = 1;
    }
    print STDERR ">>> Warning: @_\n";
    $warnings++;
}

sub error {
    print STDERR "\nSYNTAX ERROR\n";
    print STDERR ">>> Error line $line: @_\n";
    $errors++;
}

sub mesg {
    print STDERR "--- $warntag: @_\n" if ($verbose);
}
