##################################################################
#
# Check home directories
#
##################################################################
require "klib/chkrhosts.pl";

sub chkhome {
	local($gid, $path, $user, $dev, $ino, $nlink, $fuid, $fgid);
	local($uid) = shift;

	$path = $HOME{$uid};
	$user = $LOGIN{$uid};
	$gid  = $GID{$user};
	next if ! -d $path;
        ($dev, $ino, $mode, $nlink, $fuid, $fgid) = stat($path);
	next if ($DONE{$dev,$ino});

	&warn("Group-writable home directory for $user") if ($mode & 16);
	&warn("World-writable home directory for $user") if ($mode & 2);

	$fuser = $LOGIN{$fuid}; $fgroup = $LOGIN{$fgid};
	&warn("${user}'s home directory owned by $fuser")
			if ($fuid != 0 && $uid != $fuid);
	&warn("${user}'s home directory has group $fgroup")
			if ($fgid != 0 && $gid != $fgid);

	$DONE{$dev,$ino} = 1;
}

1;
