##################################################################
#
#	Check .rhosts or hosts.equiv.
#
##################################################################

sub chkrhosts {
    local($user, $rhosts) = @_;
    local($dev, $ino, $mode, $nlink, $fuid, $fgid) = stat($rhosts);
    local($fuser, $fgroup);

    $fuser = $LOGIN{$fuid}; $fgroup = $LOGIN{$fgid};

    &setwarntag("rhosts");
    &warn("World-writable .rhosts file for $user") if ($mode & 2);
    &warn("Group-writable .rhosts file for $user") if ($mode & 10);
    &warn("${user}'s .rhosts file owned by $fuser")
			if ($fuid != 0 && $uid != $fuid);
    &warn("${user}'s .rhosts file has group $fgroup")
			if ($fgid != 0 && $gid != $fgid);

    $DONE{$dev,$ino} = 1;

    if (!open(RHOSTS, "$rhosts")) {
	&warn("can't open $rhosts");
	return;
    }
    while (<RHOSTS>) {
	chop;
    	local($h, $u) = split;
	next unless ($h =~ m/\./);
	&warn("user $user has .rhosts entry for non-local host $h")
		unless ($h =~ /$domainname$/);
    }
    close RHOSTS;
}

1;
